package org.omg.DynamicAny;

import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA.BAD_PARAM;
import org.omg.CORBA.portable.ObjectImpl;
import org.omg.CORBA.Object;
import org.omg.CORBA.MARSHAL;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;

public abstract class DynArrayHelper
{
    private static String _id;
    private static TypeCode __typeCode;
    
    public DynArrayHelper() {
    }
    
    public static void insert(Any any, DynArray dynArray) {
        OutputStream create_output_stream = any.create_output_stream();
        any.type(type());
        write(create_output_stream, dynArray);
        any.read_value(create_output_stream.create_input_stream(), type());
    }
    
    public static DynArray extract(Any any) {
        return read(any.create_input_stream());
    }
    
    public static synchronized TypeCode type() {
        if (DynArrayHelper.__typeCode == null) {
            DynArrayHelper.__typeCode = ORB.init().create_interface_tc(id(), "DynArray");
        }
        return DynArrayHelper.__typeCode;
    }
    
    public static String id() {
        return DynArrayHelper._id;
    }
    
    public static DynArray read(InputStream inputStream) {
        throw new MARSHAL();
    }
    
    public static void write(OutputStream outputStream, DynArray dynArray) {
        throw new MARSHAL();
    }
    
    public static DynArray narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof DynArray)) {
            return (DynArray)object;
        }
        if (!object._is_a(id())) {
            throw new BAD_PARAM();
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _DynArrayStub dynArrayStub = new _DynArrayStub();
        dynArrayStub._set_delegate(get_delegate);
        return dynArrayStub;
    }
    
    public static DynArray unchecked_narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof DynArray)) {
            return (DynArray)object;
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _DynArrayStub dynArrayStub = new _DynArrayStub();
        dynArrayStub._set_delegate(get_delegate);
        return dynArrayStub;
    }
    
    static {
        DynArrayHelper._id = "IDL:omg.org/DynamicAny/DynArray:1.0";
        DynArrayHelper.__typeCode = null;
    }
}
